#include <iostream>

#include "library/summation.hpp"
#include "library/maxsearch.hpp"
#include "library/seqinfileenumerator.hpp"

using namespace std;

struct Hallgato
{
    string neptun;
    double atlag;
};

struct Dolgozat
{
    string neptun;
    int jegy;
};
std::istream& operator>>(std::istream& in, Dolgozat& line)
{
    in >> line.neptun >> line.jegy;
    return in;
}

struct Atlag
{
    int sum;
    int db;
};

class Atlagszamit : public Summation<Dolgozat, Atlag>
{
    std::string _akt;
protected:
    void first() override {}
    void init() override
    {
        _akt = _enor->current().neptun;
        _result->sum = 0;
        _result->db = 0;
    }
    void add(const Dolgozat& e) override
    {
        _result->sum += e.jegy;
        _result->db++;
    }
    bool whileCond(const Dolgozat& e) const override
    {
        return _akt == e.neptun;
    }
};

class EredmenyEnumerator : public Enumerator<Hallgato>
{
public:
    EredmenyEnumerator(const std::string& fname) : file(fname){}

protected:
    void first() override
    {
        file.first();
        next();
    }
    void next() override
    {
        _end = file.end();
        if(_end) return;
        res.neptun = file.current().neptun;
        Atlagszamit sum;
        sum.addEnumerator(&file);
        sum.run();
        Atlag a = sum.result();
        res.atlag = static_cast<double>(a.sum) / a.db;
    }
    bool end() const override
    {
        return _end;
    }
    Hallgato current() const override
    {
        return res;
    }

    SeqInFileEnumerator<Dolgozat> file;
    Hallgato res;
    bool _end;
};

class MaxAtlag : public MaxSearch<Hallgato,double>
{
    double func(const Hallgato& e) const override
    {
        return e.atlag;
    }

};

int main()
{
    MaxAtlag m;
    EredmenyEnumerator enor("input.txt");
    m.addEnumerator(&enor);
    m.run();
    Hallgato h = m.optElem();
    cout << h.neptun << " " << h.atlag << endl;
    return 0;
}
